//
//  ToDoTableViewController.m
//  ToDoWatch
//
//  Created by Andre M. Della Torre on 1/15/16.
//  Copyright © 2016 Andre M. Della Torre. All rights reserved.
//

#import "ToDoTableViewController.h"
#import "ToDoController.h"

@interface ToDoTableViewController ()

@end

@implementation ToDoTableViewController

#define CELL_ID @"todocell"

- (void)viewDidLoad {
    [super viewDidLoad];
    
    AppDelegate *appdelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    [appdelegate setWatchCommDelegate:self];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.tableView reloadData];
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [ToDoController toDoList].count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CELL_ID forIndexPath:indexPath];
    
    NSDictionary *toDoItem = [[ToDoController toDoList] objectAtIndex:indexPath.row];
    
    [cell.textLabel setText:[toDoItem objectForKey:TODO_TITLE_KEY]];
    
    [cell setAccessoryType: [[toDoItem objectForKey:TODO_DONE_KEY] boolValue] ? UITableViewCellAccessoryCheckmark : UITableViewCellAccessoryNone];
    
    return cell;
}


// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        
        NSDictionary *toDoItem = [[ToDoController toDoList] objectAtIndex:indexPath.row];
        
        [ToDoController deleteTodo:toDoItem];
        
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    NSDictionary *toDoItem = [[ToDoController toDoList] objectAtIndex:indexPath.row];
    [ToDoController toggleToDo:[toDoItem objectForKey:TODO_ID_KEY]];
    
    [tableView reloadData];
}

#pragma mark - WatchCommProtocol

-(void)itemToogled:(NSNumber *)toDoId {
    [ToDoController toggleToDo:toDoId];
    [self.tableView reloadData];
}

@end
