//
//  ExtensionDelegate.swift
//  ToDoWatch WatchKit Extension
//
//  Created by Andre M. Della Torre on 11/5/15.
//  Copyright © 2015 Andre M. Della Torre. All rights reserved.
//

import WatchKit
import WatchConnectivity

protocol WatchCommProtocol {
    
    func contextReceived(context : [String:AnyObject])
}

class ExtensionDelegate: NSObject, WKExtensionDelegate, WCSessionDelegate {

    var watchCommDelegate : WatchCommProtocol?
    
    func applicationDidFinishLaunching() {
        // Perform any final initialization of your application.
        
        //configura a sessao de cominicacao
        if WCSession.isSupported() {
            WCSession.defaultSession().delegate = self;
            WCSession.defaultSession().activateSession()
        }
    }

    func applicationDidBecomeActive() {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillResignActive() {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, etc.
    }
    
    // Mark : WCSessionDelegate
    
    func session(session: WCSession, didReceiveApplicationContext applicationContext: [String : AnyObject]) {

        watchCommDelegate?.contextReceived(applicationContext)
    }

}
