//
//  ToDoController.swift
//  ToDoWatch
//
//  Created by Andre M. Della Torre on 1/15/16.
//  Copyright © 2016 Andre M. Della Torre. All rights reserved.
//

import UIKit
import WatchConnectivity

class ToDoController: NSObject {

    static let TODO_LIST_KEY = "toDoList"
    static let TODO_ID_KEY = "toDoId"
    static let TODO_TITLE_KEY = "title"
    static let TODO_DONE_KEY = "done"
    static let TODO_SHARE_GROUP_NAME = "group.io.redspark.ToDoWatch"
    
    static var toDoList = ToDoController.loadToDoList()
    
    static func loadToDoList() -> [[String:AnyObject]] {
        
        //Inicializa a lista de ToDos com os item já gravados ou uma nova lista vazia.
        let defaults = NSUserDefaults.init(suiteName: TODO_SHARE_GROUP_NAME)
        if let toDos = defaults!.arrayForKey(TODO_LIST_KEY) {
            return toDos as! [[String:AnyObject]]
        }
        
        return []
    }
    
    static func updateToDoList() {
        
        //Grava a lista atual de ToDos
        let defaults = NSUserDefaults.init(suiteName: TODO_SHARE_GROUP_NAME)
        defaults!.setObject(toDoList, forKey: TODO_LIST_KEY)
        defaults!.synchronize()
    }
    
    static func addToDoItem(toDoItem: [String:AnyObject]) {

        ToDoController.toDoList.append(toDoItem)
        ToDoController.updateToDoList()
    }
    
    static func toggleToDo(toDoId: Int) {
        
        if let idx  = toDoList.indexOf( { $0[TODO_ID_KEY] as! Int == toDoId } ) {
            toDoList[idx][TODO_DONE_KEY] = !(toDoList[idx][TODO_DONE_KEY] as! Bool)
            
            ToDoController.updateToDoList()
            WCSession.defaultSession().transferUserInfo(["toogle": toDoList[idx][TODO_DONE_KEY] as! Int ])
        }
    }
    
    static func clearAll() {
        ToDoController.toDoList = []
    }
}
